AliAnalysisTaskSELc2V0bachelor *AddTaskLc2V0bachelor(TString finname="Lc2V0bachelorCuts.root",
						     Bool_t theMCon=kFALSE)

{

  AliAnalysisManager *mgr = AliAnalysisManager::GetAnalysisManager();
  if (!mgr) {
    ::Error("AddTaskLc2V0bachelor", "No analysis manager to connect to.");
    return NULL;
  }  
  
  // cuts are stored in a TFile generated by makeTFile4CutsLc2V0bachelor.C in ./macros/
  // set there the cuts!!!!!

  Bool_t stdcuts=kFALSE;
  TFile* filecuts;
  if( finname.EqualTo("") ) {
    stdcuts=kTRUE; 
  } else {
      filecuts=TFile::Open(finname.Data());
      if(!filecuts ||(filecuts&& !filecuts->IsOpen())){
	AliFatal("Input file not found : check your cut object");
      }
  }

  AliRDHFCutsLctoV0* RDHFCutsLctoV0prod = new AliRDHFCutsLctoV0();
  if (stdcuts) RDHFCutsLctoV0prod->SetStandardCutsPP2010();
  else RDHFCutsLctoV0prod = (AliRDHFCutsLctoV0*)filecuts->Get("LctoV0ProductionCuts");
  RDHFCutsLctoV0prod->SetName("LctoV0ProductionCuts");
  RDHFCutsLctoV0prod->SetMinPtCandidate(-1.);
  RDHFCutsLctoV0prod->SetMaxPtCandidate(10000.);

  AliRDHFCutsLctoV0* RDHFCutsLctoV0anal = new AliRDHFCutsLctoV0();
  if (stdcuts) RDHFCutsLctoV0anal->SetStandardCutsPP2010();
  else RDHFCutsLctoV0anal = (AliRDHFCutsLctoV0*)filecuts->Get("LctoV0AnalysisCuts");
  RDHFCutsLctoV0anal->SetName("LctoV0AnalysisCuts");
  RDHFCutsLctoV0anal->SetMinPtCandidate(-1.);
  RDHFCutsLctoV0anal->SetMaxPtCandidate(10000.);


  // mm let's see if everything is ok
  if (!RDHFCutsLctoV0prod || !RDHFCutsLctoV0anal) {
    cout << "Specific AliRDHFCutsLctoV0 not found\n";
    return;
  }


  //CREATE THE TASK

  printf("CREATE TASK\n");
  AliAnalysisTaskSELc2V0bachelor *task = new AliAnalysisTaskSELc2V0bachelor("AliAnalysisTaskSELc2V0bachelor",RDHFCutsLctoV0prod,RDHFCutsLctoV0anal);
  task->SetMC(theMCon);
  task->SetK0sAnalysis(kTRUE);
  task->SetDebugLevel(0);
  mgr->AddTask(task);

  // Create and connect containers for input/output  
  TString outputfile = AliAnalysisManager::GetCommonFileName();
  outputfile += ":PWG3_D2H_Lc2pK0S";


  mgr->ConnectInput(task,0,mgr->GetCommonInputContainer());

  // ----- output data -----
  AliAnalysisDataContainer *coutput1 = mgr->CreateContainer("chist1",TList::Class(),AliAnalysisManager::kOutputContainer,outputfile.Data()); // general histos
  mgr->ConnectOutput(task,1,coutput1);
  AliAnalysisDataContainer *coutputLc1 = mgr->CreateContainer("Lc2pK0SAll",TList::Class(),AliAnalysisManager::kOutputContainer,outputfile.Data()); // production histos
  mgr->ConnectOutput(task,2,coutputLc1);
  AliAnalysisDataContainer *coutputLc2 = mgr->CreateContainer("Lc2pK0SPIDBach",TList::Class(),AliAnalysisManager::kOutputContainer, outputfile.Data()); // analysis histos
  mgr->ConnectOutput(task,3,coutputLc2);
  AliAnalysisDataContainer *coutputLc3 = mgr->CreateContainer("Lc2pK0Scounter",AliNormalizationCounter::Class(),AliAnalysisManager::kOutputContainer, outputfile.Data()); //counter
  mgr->ConnectOutput(task,4,coutputLc3);
  AliAnalysisDataContainer *coutputLc4 = mgr->CreateContainer("Lc2pK0SCuts",TList::Class(),AliAnalysisManager::kOutputContainer,outputfile.Data()); // cuts
  mgr->ConnectOutput(task,5,coutputLc4);

  return task;

}
